/* Fetch documents via HTTP or FTP by URL */
call RxFuncAdd 'SysLoadFuncs','RexxUtil','SysLoadFuncs'
call SysLoadFuncs
call RxFuncAdd 'SockLoadFuncs','RxSock','SockLoadFuncs'
signal on SYNTAX
nosock=1
call SockLoadFuncs 'q'
nosock=0
signal off SYNTAX

exitval=-1
rxiversion=0.09
parse version rxversion
if word(rxversion,1)\='OBJREXX' then do
	say ''
	say 'HTTPGET.CMD requires Object REXX to function.'
	say ''
	say 'You are running: '||rxversion
	say ''
	say 'README.TXT contains more information.'
    exit 6
end
rxversion=rxversion~word(2)

signal on HALT
/*
signal on SYNTAX
*/
signal on ERROR
/* For debugging only. */
signal on NOVALUE
signal on FAILURE
probtype=0

parse source progpath
progpath=progpath~subword(3)
pdrive=filespec('drive',progpath)
ppath=filespec('path',progpath)
emfile=.stream~new(pdrive||ppath||'urlem.cfg')

if emfile~query('exists')='' then do
    say ''
    say 'E-mail address config file not found.'
    say ''
    say 'Please enter your e-mail address for anonymous FTP transfers:'
    parse pull emadd
    if emadd~pos('@')=0 then do
        say ''
        say 'Invalid e-mail address.'
        exit 2
    end
    else emfile~lineout(emadd)
    emfile~close
end
else emadd=emfile~linein
emfile~close
        
quietmode=0
parse arg parm
if parm~pos('"')>0 then do until parm~pos('"')=0
    parse var parm before '"' after
    parm=before||after
end
if parm~strip~translate~left(2)='/Q' then do
	parm=parm~right(parm~length-2)~strip
	quietmode=1
end
if parm~strip~translate~right(2)='/Q' then do
	parm=parm~left(parm~length-2)~strip
	quietmode=1
end
if parm~strip~left(1)='@' then do
	parse var parm '@' urllist ' ' .
	ulist=.stream~new(urllist)
	if ulist~query('exists')='' then do
		say ''
		say 'URL list file not found!'
        exit 2
	end
	else host='fromfile'
end
else if parm~translate~left(7)='HTTP://' |,
        parm~translate~left(6)='FTP://' then host='fromparm'
else do
    call usage rxiversion
    exit 2
end
urls=.queue~new

if host='fromfile' then do while ulist~lines>0
	urls~queue(ulist~linein)
end
else urls~queue(parm)
urls=urls~makearray
	
currdrive=directory()~left(2)
fatcheck=SysFileSystemType(currdrive)

srow=-1
crlf='0d0a'x
headend=crlf||crlf
blocksize=10240
maxretries=100
call SysCurState 'off'
con=.stream~new('stdout')
success=0
failure=0
sockfail=0
servfail=0

do i=1 to urls~items
    retries=0
    newname=0
    parse value urls[i] with prot '://' host '/' path ';' lfile
    prot=prot~strip~translate
    if prot\='HTTP' & prot\='FTP' then do
        if urls~items>1 then do
            failure=1
            iterate i
        end
        else do
            call usage rxiversion
            exit 2
        end
    end
    host=host~strip
    if host='' | host~pos(' ')>0 then do
        if urls~items>1 then do
            failure=1
            iterate i
        end
		else do
            call usage rxiversion
            exit 2
		end
    end
    if prot='HTTP' then do
        parse var host host ':' port
        port=port~strip
        if port='' then port=80
    end
    else do
        if host~pos('@')>0 then do
            parse var host userpass '@' host
            if userpass~pos(':')>0 then parse var userpass user ':' pass
            else do
                if urls~items>1 then do 
                    failure=1
                    iterate i
                end
                else do
                    say ''
                    say 'Invalid FTP URL supplied.'
                    exit 2
                end
            end
            user=user~strip
            pass=pass~strip
            parse var host host ':' port
            port=port~strip
            if port='' then port=21
            host=host~strip
        end
        else do
            user='anonymous'
            pass=emadd
            parse var host host ':' port
            port=port~strip
            if port='' then port=21
            host=host~strip
        end
    end
	if path~pos('/')>0 then do
		rpath=path~reverse
		parse var rpath file '/' dirpath
		file=file~reverse~strip
        dirpath='/'||dirpath~reverse~strip
	end
	else do
		file=path~strip
		dirpath='/'
	end
    if file='' then do
        if urls~items>1 then do
            failure=1
            iterate i
        end
		else do
            call usage rxiversion
            exit 2
		end
    end
	lfile=lfile~strip
	if lfile='' then lfile=file
    if dirpath~pos(' ')>0 & prot='HTTP' then do until dirpath~pos(' ')=0
        parse var dirpath before ' ' after
        dirpath=before||'%20'||after
    end
	longea=0
    dfile=file
    if file~pos(' ')>0 & prot='HTTP' then do until file~pos(' ')=0
        parse var file before ' ' after
        file=before||'%20'||after
    end
    ldrive=filespec('drive',lfile)
    if ldrive\='' then do
        fatcheck=SysFileSystemType(ldrive)
    end
    if fatcheck='FAT' then do
        ldrive=filespec('drive',lfile)
        if ldrive='' then ldrive='DEF'
        lpath=filespec('path',lfile)
        if lpath='' then lpath='DEF'
        lname=filespec('name',lfile)
        parse var lname basename '.' ext
        parse value lname~reverse with ext2 '.' basename2
		select 
			when ext\=ext2~reverse then newname=1
			when basename\=basename2~reverse then newname=1
			when basename~length>8 then newname=1
			when ext~length>3 then newname=1
			when basename~pos(' ')>0 then newname=1
			when ext~pos(' ')>0 then newname=1
            otherwise newname=0
		end
		if newname=1 then do
			if ext~length<=3 then shext='.'||ext
            else shext='.UGF'
		end
		done=0
		if newname=1 then do until done=1
			p1=right(d2x(random(65535)),4,'0')
			p2=right(d2x(random(65535)),4,'0')
            select
                when ldrive='DEF' & lpath='DEF' then ltot=p1||p2||shext
                when ldrive='DEF' then ltot=lpath||p1||p2||shext
                when lpath='DEF' then ltot=ldrive||p1||p2||shext
                otherwise ltot=ldrive||lpath||p1||p2||shext
            end
            outfile=.stream~new(ltot)
			if outfile~query('exists')='' then do
				done=1
				longea=1
                longval='FDFF'x||filespec('name',lfile)~length~d2c||,
                        '00'x||filespec('name',lfile)
                lname=filespec('name',outfile~qualify)
                select
                    when ldrive='DEF' & lpath='DEF' then lfile=lname
                    when ldrive='DEF' then lfile=lpath||lname
                    when lpath='DEF' then lfile=ldrive||lname
                    otherwise lfile=ldrive||lpath||lname
                end
            end
		end
		else outfile=.stream~new(lfile)
	end
	else outfile=.stream~new(lfile)
	call SysFileDelete outfile~qualify

	servport=host||':'||port

    if prot='HTTP' then httpsendstring='GET '||dirpath||'/'||file||' HTTP/1.0'||crlf||,
                       'Accept: */*'||crlf||,
                       'Accept-Encoding: */*'||crlf||,
                       'User-Agent: URLGet/'||rxiversion||'  Object REXX/'||rxversion||crlf||,
                       crlf
    else do
        ftpcmds=.queue~new
        ftpcmds~queue(.ftpcommand~new('Initial Connection','NULL', ,
            .queue~new~~queue('220')~makearray,'NULL','NULL'))
        ftpcmds~queue(.ftpcommand~new('Send User Name','USER', ,
            .queue~new~~queue('331')~makearray,user,'NULL'))
        ftpcmds~queue(.ftpcommand~new('Send Password','PASS', ,
            .queue~new~~queue('230')~makearray,pass,'NULL'))
        ftpcmds~queue(.ftpcommand~new('Set Mode Binary','TYPE', ,
            .queue~new~~queue('200')~makearray,'I','NULL'))
        ftpcmds~queue(.ftpcommand~new('Change Working Directory','CWD', ,
            .queue~new~~queue('250')~makearray,dirpath, ,
            .queue~new~~queue('550')~~queue('450')~makearray))
        ftpcmds~queue(.ftpcommand~new('Get File Stats','STAT', ,
            .queue~new~~queue('211')~~queue('213')~makearray, ,
            file,.queue~new~~queue('450')~~queue('550')~makearray))
        ftpcmds~queue(.ftpcommand~new('Set Passive','PASV', ,
            .queue~new~~queue('227')~makearray,'NULL','NULL'))
        ftpcmds~queue(.ftpcommand~new('Request File','RETR', ,
            .queue~new~~queue('125')~~queue('150')~makearray, ,
            file,.queue~new~~queue('450')~~queue('550')))
        ftpcmds=ftpcmds~makearray
    end
            

	csock=.socket~new

	call SysCls
	say ''
	say ''
	say 'Connecting to host '||host||' on port '||port||'...'
	check=csock~connect(servport)
	if check='HALT' then signal HALT
	if check=-1 then do
		say 'Connection to host '||host||' on port '||port||' failed!'
        call sockclean('control')
        sockfail=1
        failure=1
        iterate i
	end
	say ''

/* Nice simple HTTP file request. */

    if prot='HTTP' then do
        check=csock~send(httpsendstring)
        if check='HALT' then signal HALT
        if check=-1 then do
            say 'Failed to send file request!'
            call sockclean('control')
            sockfail=1
            failure=1
            iterate i            
        end
    end

/* Welcome to FTP hell. */

    else do 
        rval=FTPProc(ftpcmds,csock)
        select
            when rval='HALT' then signal HALT
            when rval~objectname='an Array' then do
                dsock=rval[1]
                size=rval[2]
            end
            when rval=3 then do
                call sockclean
                sockfail=1
                failure=1
                iterate i
            end
            when rval=4 then do
                call sockclean
                servfail=1
                failure=1
                iterate i
            end
            otherwise do
                call sockclean
                failure=1
                iterate i
            end
        end
    end        

    total=0
    nofile=0     
    headgone=0
	dumbserver=0
	finished=0
	call time 'r'
	do until finished=1
        if prot='HTTP' then check=csock~receive(blocksize)
        else check=dsock~receive(blocksize)
		if check='HALT' then signal HALT
		rvar=check[2]
        if rvar<0 then do
			if retries>maxretries then finished=1
			else retries=retries+1
		end
        else if rvar=0 then finished=1
        data=check[1]
/* Remove this line for 406 returns! 
		headgone=1
		size=0
   Remove this line for 406 returns! */
        if headgone=0 then do
            if prot='HTTP' & data~word(2)='404' then nofile=1
            else if prot='HTTP' & data~word(2)='406' then dumbserver=1
            else if data~pos(headend)>0 | prot='FTP' then do
				headgone=1
                say prot||' receive of file '||dfile||'...'
                if lfile\=file then say 'Stored locally as '||lfile||'...'
				say ''
				if quietmode\=1 then do
					parse value SysCurPos() with row col
					srow=row+2
					call SysCurPos row,0
					con~charout('Bytes received: ')
					con~close
					call SysCurPos row,32
					con~charout('Bytes/second: ')
					con~charout(crlf||crlf)
					con~close
					call SysCurPos srow,0
					con~charout('Total size: ')
					con~close
					call SysCurPos srow,36
					con~charout('Progress: ')
					con~close
					lastb=0
					lastt=0
					calc=0
					next=0
					lr1=0
					lr2=0
					lr3=0
					percent=0
					npercent=0
					freq=2048
					pstep=1
					lbchange=1
				end
                if prot='HTTP' then do
                    parse var data header (headend) data
                    if header~pos('ength:')>0 then do
                        header=header||crlf
                        parse var header 'ength:' size (crlf)
                        size=size~strip
                        if size~datatype='NUM' then nop
                        else size=0
                    end
                    else size=0
                end
                if size=0 then do
					if quietmode\=1 then do
						call SysCurPos srow,13
						con~charout('UNKNOWN')
						con~close
						call SysCurPos srow,46
						con~charout('UNKNOWN')
						con~close
					end
					else do
						say 'Total size: UNKNOWN'
						say ''
					end
				end
                if quietmode\=1 then do
                    call SysCurPos srow,13
                    con~charout(codel(size)||' bytes')
                    con~close                        
                    call SysCurPos srow,49
                    con~charout('%')
                    con~close
                end
                else do
                    say 'Total size: '||codel(size)||' bytes'
                    say ''
                end
				outfile~charout(data)
				total=total+data~length
				if quietmode\=1 then do
					if total>=next | finished=1 then do
						next=total+freq
						call SysCurPos row,16
						con~charout(codel(total)~left(12))
						con~close
						ct=time('e')
						if ct=0 then ct=0.01
						interval=ct-lastt
						if interval=0 then interval=0.01
						rate=(total-lastb)%(interval)
						if lbchange=1 then do
                            lbchange=5
							lastt=ct
							lastb=total
						end
                        else lbchange=lbchange-1
						call SysCurPos row,46
						con~charout(rate~left(12))
						con~close
					end
				end
			end
		end
		else do
			outfile~charout(data)
			total=total+data~length
			if quietmode\=1 then do
				if total>=next | finished=1 then do
					next=total+freq
					call SysCurPos row,16
					con~charout(codel(total)~left(12))
					con~close
					ct=time('e')
					if ct=0 then ct=0.01
					interval=ct-lastt
					if interval=0 then interval=0.01
					rate=(total-lastb)%(interval)
					if lbchange=1 then do
                        lbchange=5
						lastt=ct
						lastb=total
					end
                    else lbchange=lbchange-1
					if total>50000 then do
                        if lr3=0 then pravg=(lr1+lr2)/2
                        else if lr2=0 then pravg=lr1
                        else if lr1=0 then pravg=rate
                        else pravg=(lr1+lr2+lr3)/3
                        if rate%pravg>=2 then nf=pravg/2
                        else nf=rate/2
                        if nf%freq>=2 then freq=freq*2
                        else freq=nf
					end
					lr3=lr2
					lr2=lr1
					lr1=rate
					call SysCurPos row,46
					con~charout(codel(rate)~left(12))
					con~close
				end
				if size=0 then nop
				else if total>=npercent | finished=1 then do
					percent=(total/size*100)~format(,0)
					npercent=(total+(rate+lr1+lr2+lr3)/16)~format(,0)
					call SysCurPos srow,46
					con~charout(percent)
					con~close
				end
			end
		end
		if finished=1 then do
			if size>0 then do
				if total<size then do
					say ''
					say ''
					say 'Maximum retries reached - transfer failed!'
                    sockfail=1
                    failure=1
				end
			end
			ct=time('e')
			rate=total%ct
			if quietmode\=1 then do
				say ''
				say ''
			end
			say codel(total)||' bytes received in '||ct~format(,3)||,
					' seconds ('||codel(rate)||' bytes/sec.)'
		end
		if nofile=1 then do
			say "Remote file doesn't exist!"
			longea=0
		end
		if dumbserver=1 then do
			say ''
			say ''
			say "Incorrect protocol usage at remote server, returned 406!"
			longea=0
		end
		if nofile=1 | dumbserver=1 then leave
	end
    if nofile\=1 then do
        success=1
        outfile~close 
    end
	if longea=1 then call SysPutEA outfile~qualify,'.LONGNAME',longval

/* Log off the FTP server.  If it doesn't get the command, oh well. */
    
    if prot='FTP' then do    
        junk=csock~receive(1024)  /* Ignore 226 for now. */
        check=csock~send('QUIT'||crlf)
        dsock~shutdown('both')
        dsock~close
    end
    csock~shutdown('both')
	csock~close
end

select 
    when success=1 & failure=0 then exitval=0
    when success=1 & failure=1 then exitval=1
    when urls~items=1 & sockfail=1 then exitval=3
    when urls~items=1 & servfail=1 then exitval=4
    when urls~items>1 & sockfail=1 & servfail=1 & success=0 then exitval=30
    otherwise exitval=255
end

exit exitval

SYNTAX:
if nosock=1 then do
    say ''
    say 'Failed to lock REXX Socket functions.'
    say ''
    say 'Program cannot continue.'
    exit 6
end
probtype='SYNTAX'
probline=sigl
signal handler
ERROR:
probtype='ERROR'
probline=sigl
signal handler
NOVALUE:
probtype='NOVALUE'
probline=sigl
signal handler
FAILURE:
probtype='FAILURE'
probline=sigl
signal handler
handler:
call SysCls
say ''
say ''
say ''
say ''
say 'Problem of type '||probtype||' on source line #'||probline||'!!'
say ''
say 'Source line content:'
say sourceline(probline)
say ''
say 'Please notify thanny@home.com about this, with as much possible detail.'
exitval=6
HALT: 
if quietmode\=1 then do
    if srow=-1 | datatype(srow,'num')=0 then do
		parse value SysCurPos() with row col
		srow=row+2
	end
	call SysCurPos srow,75
end
else do
	say ''
	say ''
end
say ''
say ''
say 'Aborting!'
call sockclean
if exitval=-1 then do
    if success=0 then exitval=5
    else if success=1 & urls~items>=i then exitval=1
    else if success=1 & failure=0 then exitval=0
end
exit exitval

sockclean: procedure expose csock dsock

if csock~objectname='a socket' then do
    csock~shutdown('both')
    csock~close
end
if dsock~objectname='a socket' then do
    dsock~shutdown('both')
    dsock~close
end
return

/* Socket class - work in progress **********************************/
/*																	*/
::class 'socket'

::method init
expose portnum
portnum=SockSocket('AF_INET','SOCK_STREAM',0)
return

::method sock
expose portnum
return portnum

::method connect
use arg servname
signal on HALT
parse var servname hostname ':' host.!port
parse var hostname o1 '.' o2 '.' o3 '.' o4
if o1~datatype='NUM' & o2~datatype='NUM' & o3~datatype='NUM' &,
   o4~datatype='NUM' then do
	if o1~datatype('w')=1 & o2~datatype('w')=1 & o3~datatype('w')=1 &,
	   o4~datatype('w')=1 then do
		if (o1>=0 & o1<=255) & (o2>=0 & o2<=255) & (o3>=0 & o3<=255) &,
		   (o4>=0 & o4<=255) then do
			stype='IP'
			host.!addr=hostname
		end
	end
end
else stype='NAME'            
if stype='NAME' then call SockGetHostByName hostname,'host.!'
host.!family='AF_INET'
rc=SockConnect(self~sock,'host.!')
return rc
HALT:
return 'HALT'

::method send
use arg sendstring
signal on HALT
rc=SockSend(self~sock,sendstring)
return rc
HALT:
return 'HALT'

::method receive
use arg length
signal on HALT
if length='LENGTH' then length=1024
check=SockRecv(self~sock,'sockdata',length)
return .array~new~~put(sockdata,1)~~put(check,2)
HALT:
return 'HALT'

::method shutdown
use arg how
select
	when how~translate='FROM' then how=0
	when how~translate='TO' then how=1
	otherwise how=2
end
call SockShutDown self~sock,how
return

::method close
call SockClose self~sock
return
/*																	*/
/********************************************************************/

/* FTP command object ***********************************************/
/*                                                                  */
::class FTPCommand

::method init
expose cmdlabel cmdname svals parm sfail
use arg cmdlabel,cmdname,svals,parm,sfail

::method name
expose cmdname
return cmdname

::method svals
expose svals
return svals~items

::method sval
expose svals
arg num
return svals[num]

::method parm
expose parm
return parm

::method label
expose cmdlabel
return label

::method failures
expose sfail
if sfail='NULL' then return 0
return sfail~items

::method failure
expose sfail
arg num
return sfail[num]
/*                                                                  */
/********************************************************************/

/* Comma deliminator routine ****************************************/
/*																	*/
::routine codel
use arg RNum
if RNum~length<3 then return RNum
RNum=RNum~reverse
FNum=''
do while RNum~length>3
	parse var RNum TriDig +3 RNum
	FNum=FNum||TriDig||','
end
FNum=FNum||RNum
return FNum~reverse
/*																	*/
/********************************************************************/

/* Display usage information ****************************************/
/*																	*/
::routine usage
use arg version
say ''
say 'URL file fetcher v'||version
say ''
say 'Usage:'
say ''
say 'urlget.cmd [/q] <URL name [;local name] | @filename> [/q]'
say ''
say 'URL name - URL of file to get'
say ''
say 'local name - local name to store file as'
say ''
say "@filename - text file with multiple URL's, one on a line"
say ''
say '/q - operate in quiet mode'
say ''
say 'e.g. urlget http://www.somewhere.com/index.html'
return
/*																	*/
/********************************************************************/

/* FTP login and transfer preparation stuff *************************/
/*                                                                  */
::routine FTPProc
use arg ftpcmds,csock

crlf='0d0a'x

do fti=1 to ftpcmds~items
    if ftpcmds[fti]~name='NULL' then nop
    else do
        name=ftpcmds[fti]~name
        parm=ftpcmds[fti]~parm
        if parm='NULL' then parm='' 
        else parm=' '||parm
        check=csock~send(ftpcmds[fti]~name||parm||crlf)
        if check='HALT' then signal HALT
        if check=-1 then do
            say ftpcmds[fti]~label||' failed!'
            return 3
        end
    end
    check=csock~receive(1024)
    if check='HALT' then signal HALT
    if check[2]=-1 then do
        say ftpcmds[fti]~label|' failed!'
        return 3
    end
    recd=check[1]
    sfail=0
    spass=0
    cname=ftpcmds[fti]~name
    if ftpcmds[fti]~failures>0 then do sf=1 to ftpcmds[fti]~failures
        if check[1]~left(3)=ftpcmds[fti]~failure(sf) then sfail=1
    end
    if sfail=1 then do
        select
            when cname='STAT' | cname='RETR' then do
                say "File doesn't exist, or access level insufficient!"
                return 4
            end
            when cname='CWD' then do
                say "Path doesn't exist, or access level insufficient!"
                return 4
            end
            otherwise do
                say 'Unspecified server error!'
                return 4
            end
        end
    end
    do sc=1 to ftpcmds[fti]~svals
        if check[1]~left(3)=ftpcmds[fti]~sval(sc) then do
            sval=ftpcmds[fti]~sval(sc)
            spass=1
            leave sc
        end
    end
    if spass=0 then do
        say ftpcmds[fti]~label||' failed!'
        return 4
    end
    done=0
    if check[1]~left(4)=sval||'-' then do until done=1
        bend=sval||' '
        parse var recd (bend) stuff
        if stuff\='' & stuff~right(2)=crlf then leave        
        scrap=check[1]
        check=csock~receive(1024)
        if check='HALT' then signal HALT
        if check[2]=-1 then do
            say ftpcmds[fti]~label||' failed!'
            return 3
        end
        recd=recd||check[1]
        scrap=scrap||check[1]
        do until scrap~pos(crlf)=0
            parse var scrap begin (crlf) scrap
            if begin~left(4)=sval||' ' then pdone=1
            else pdone=0
        end
        if scrap='' & pdone=1 then done=1
    end
    select
        when cname='STAT' then do
            file=parm~strip
            do until recd~pos(crlf)=0
                parse var recd begin (crlf) recd
                if begin~translate~pos(file~translate)>0 then do
                    if begin~left(4)=sval||'-' then nop
                    else do
                        size=begin~word(5)
                        recd=''
                    end
                end
            end
        end
        when cname='PASV' then do
            parse var recd . '(' hostport ')' .
            parse var hostport h1 ',' h2 ',' h3 ',' h4 ',' p1 ',' p2
            host=h1||'.'||h2||'.'||h3||'.'||h4
            port=(p1~d2c||p2~d2c)~c2d
            servport=host||':'||port
            dsock=.socket~new
            check=dsock~connect(servport)                                                                                             
            if check='HALT' then signal HALT                                    
            if check=-1 then do                                                 
                say 'Data connection to host '||host||' on port '||port||' failed!'  
                return 3
            end                                                                 
        end
        otherwise nop
    end                            
end        
rval=.queue~new
rval~queue(dsock)
rval~queue(size)
rval=rval~makearray
return rval

HALT:
return 'HALT'
/*                                                                      */
/************************************************************************/
